#include <SoftwareSerial.h>
 
const int rxPin = 3; //SoftwareSerial RX pin
const int txPin = 2; //SoftwareSerial TX pin
                     
const int RELE_K1  = 7;    //pin collegato al relè K1
const int RELE_K2  = 6;    //pin collegato al relè K2
const int RELE_K3  = 4;    //pin collegato al relè K3
const int RELE_K4  = 5;    //pin collegato al relè K4
 
SoftwareSerial bluetooth(rxPin, txPin); // RX, TX
 
String strsValues;

void setup() {
    //setta il baudrate della seriale
    Serial.begin(9600); 
    
    pinMode(RELE_K1, OUTPUT);
    pinMode(RELE_K2, OUTPUT);
    pinMode(RELE_K3, OUTPUT);
    pinMode(RELE_K4, OUTPUT);
    
    setupBT();
}

 /*
 iniziallizza la comunicazione bluetooth
 */
  void setupBT(){
    bluetooth.begin(115200);  // Di default è settato a 115200bps
    // manda il comando di per far entrare il modulo bt in "command mode"
    bluetooth.print("$"); 
    bluetooth.print("$");
    bluetooth.print("$");  
     
    delay(100);  // Ritardo per aspettare la risposta del modulo btD
    
    bluetooth.println("U,9600,N");  // cambia temporaneamente il baudrate a 9600, no parity
    bluetooth.begin(9600);  // Setta il bluetooth seriale a 9600
 
  }
 
void loop() {

  if(bluetooth.available() > 0){
     Serial.print("Ricevuto: ");
            
      char c = bluetooth.read();
     
      if (c == 's'){
        Serial.println( "stop" );
      }else {
        strsValues += c;
        Serial.println( strsValues );
      }
      delay(5);
    }else if (strsValues == "k1_0"){
      Serial.println( "set k1 off" );
      digitalWrite(RELE_K1, LOW);
      resetValues();
     
    }else if (strsValues == "k1_1"){
      Serial.println( "set k1 on" );
      digitalWrite(RELE_K1, HIGH);
      resetValues();
    }else if (strsValues == "k2_0"){
      Serial.println( "set k2 off" );
      digitalWrite(RELE_K2, LOW);
      resetValues();
     
    }else if (strsValues == "k2_1"){
      Serial.println( "set k2 on" );
      digitalWrite(RELE_K2, HIGH);
      resetValues();
    }else if (strsValues == "k3_0"){
      Serial.println( "set k3 off" );
      digitalWrite(RELE_K3, LOW);
      resetValues();
     
    }else if (strsValues == "k3_1"){
      Serial.println( "set k3 on" );
      digitalWrite(RELE_K3, HIGH);
      resetValues();
    }else if (strsValues == "k4_0"){
      Serial.println( "set k4 off" );
      digitalWrite(RELE_K4, LOW);
      resetValues();
     
    }else if (strsValues == "k4_1"){
      Serial.println( "set k4 on" );
      digitalWrite(RELE_K4, HIGH);
      resetValues();
    }
  
  delay(100);


}

void resetValues(){
   strsValues     = "";
}
